#!/bin/bash
# COPYRIGHT BY PRAMI @ RETURN OF THE SHADOW 2002 
# RETURN OF THE SHADOW MUD www.rots.org
# Distributed under circlemud license
# Put the script in your lib/world directory
# and start it by ./makezones.sh <zone_to_start> <zone_to_end>
# for example, ./makezones.sh 250 260
#
# You WILL need to provide template files (names below) in the 
# associated directories. I call them n.wld/n.zon/n.mob
# 
WLD_TEMPLATE_FILE=n.wld
ZON_TEMPLATE_FILE=n.zon
MOB_TEMPLATE_FILE=n.mob 
 
          if [ -z "$1" ]; then 
              echo usage: $0 A B
              echo first variable A is the starting zone
              echo second variable B is the ending zone
              echo I will make zones from A to B
              echo ./makezones.sh 300 310
              exit
          fi

          if [ -z "$2" ]; then 
              echo usage: $0 two variables please
              exit
          fi

          if [ "$1" -eq "0" ]; then 
              echo usage: first variable $1 should be numeric and nonzero p
lease
              exit
          fi

          if [ "$2" -eq "0" ]; then 
              echo usage: second variable $2 should be numeric and nonzero 
 please
              exit
          fi

	  if [ "$2" -lt "$1" ]; then
	       echo The second number should be larger then the first number.
	       exit
	  fi

echo I will be making total of $[$2-$1+1] zones.

# let's find the templates
if [ -e wld/$WLD_TEMPLATE_FILE ];
    then 
	echo Found room template. I am happy so far.
    else
	echo Did not find the room template file
	exit
fi

if [ -e zon/$ZON_TEMPLATE_FILE ];
    then 
	echo Found zone template. I am happy so far.
    else
	echo Did not find the zone template file
	exit
fi

if [ -e mob/$MOB_TEMPLATE_FILE ];
    then 
	echo Found mob template. I am happy so far.
    else
	echo Did not find the mob template file
	exit
fi


# let's find the index files
if [ ! -e wld/index ];
    then 
        echo Missing the room index file. 
	exit
fi
if [ ! -e zon/index ];
    then 
        echo Missing the zone index file. 
	exit
fi
if [ ! -e mob/index ];
    then 
        echo Missing the mob index file. 
	exit
fi
	

for i in `seq $1 $2`;
do
    if [ -e wld/$i.wld ];
    then 
     echo Found existing file $i.wld. Skipping it 
     echo If you really mean to recreate it, delete it first.
    else
    #we'll create this room now
     sed -e 's/#\$\$/'"#$i/g" wld/$WLD_TEMPLATE_FILE > wld/$i.wld
    #let's see if this zone already exists in the index
     ZONE_IN_INDEX=`grep $i.wld wld/index -c`
     if [ $ZONE_IN_INDEX -eq 0 ];
	then 
	# this zone is not in index
	echo $i.wld >> wld/index
     fi
   fi
    
    if [ -e zon/$i.zon ];
    then 
     echo Found existing file $i.zon. Skipping it 
     echo If you really mean to recreate it, delete it first.
    else 
     sed -e 's/\$\$'"/$i/g" zon/$ZON_TEMPLATE_FILE > zon/$i.zon
    #let's see if this zone already exists in the index
     ZONE_IN_INDEX=`grep $i.zon zon/index -c`
     if [ $ZONE_IN_INDEX -eq 0 ];
	then 
	# this zone is not in index
	echo $i.zon >> zon/index
     fi
    fi
 
    if [ -e mob/$i.mob ];
    then 
     echo Found existing file $i.mob. Skipping it 
     echo If you really mean to recreate it, delete it first.
    else 
     cp mob/$MOB_TEMPLATE_FILE mob/$i.mob
    #let's see if this zone already exists in the index
     ZONE_IN_INDEX=`grep $i.mob mob/index -c`
     if [ $ZONE_IN_INDEX -eq 0 ];
        then
        # this zone is not in index
        echo $i.mob >> mob/index
     fi
    fi

done

echo Finished making zones.

# last but not the list, let's clean up the index files
for i in wld zon mob
do
# we are gonna delete the $ symbol which is somewhere inside
sed -e '/\$/d' $i/index > $i/index.1
# now we'll sort the file itself
sort -g $i/index.1 > $i/index.2
# let's add the trailing $ symbol at the end
echo \$ >> $i/index.2
mv $i/index $i/index.bak
rm $i/index.1
mv $i/index.2 $i/index

echo Finished polishing index files.
done
